

function ___$insertStyle(css) {
    if (!css || typeof window === 'undefined') {
        return;
    }
    const style = document.createElement('style');
    style.setAttribute('type', 'text/css');
    style.innerHTML = css;
    document.head.appendChild(style);
    return css;
}

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var Accordion = require('react-collapsible-accordion-accessible');
var fa = require('react-icons/fa');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n["default"] = e;
    return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);
var Accordion__default = /*#__PURE__*/_interopDefaultLegacy(Accordion);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

___$insertStyle(".jsonviewer-root {\n  display: flex;\n  flex-direction: column;\n}\n\n.jsonnode-root {\n  padding: 0.2rem 0;\n}\n\n.jsonnode-content {\n  display: flex;\n  flex-direction: row;\n}\n\n.jsonnode-title {\n  margin-left: 1.8rem;\n  margin-right: 0.5rem;\n}\n\n.jsonnode-seperator {\n  margin-right: 1rem;\n}\n\n.jsonnode-root .accordion-root {\n  padding: 0;\n  margin: 0;\n}\n\n.jsonnode-root .accordion-header {\n  background-color: #fff;\n}\n\n.jsonnode-root .accordion-header:hover {\n  background-color: #eff3f6;\n  border-radius: 0.2rem;\n}\n\n.jsonnode-root .accordion-title {\n  order: 2;\n  margin-left: 0.5rem;\n  font-size: medium;\n  font-weight: normal;\n  transition: all 0.1s ease;\n  padding: 0.1rem 0.2rem;\n}\n\n.jsonnode-root .accordion-title:hover {\n  background-color: #eff3f6;\n  border-radius: 0.2rem;\n}\n\n.jsonnode-root .accordion-icon {\n  margin-right: 0;\n  font-size: 1.5em;\n}\n\n.jsonnode-root .accordion-icon-expanded {\n  margin-right: 0;\n  font-size: 1.5em;\n  transform: rotate(90deg);\n}\n\n.jsonnode-root .accordion-expanded-icon {\n  margin-right: 0;\n  font-size: 1.5em;\n}\n\n.jsonnode-root .accordion-icon:hover {\n  background-color: #eff3f6;\n  border-radius: 0.2rem;\n}\n\n.jsonnode-root .accordion-expanded-icon:hover {\n  background-color: #eff3f6;\n  border-radius: 0.2rem;\n}\n\n.jsonnode-root .accordion-header-button {\n  justify-content: flex-start;\n  padding: 0;\n  transition: all 0.1s ease;\n}\n\n.jsonnode-root .accordion-content {\n  background-color: #fff;\n  text-align: left;\n}\n\n.jsonnode-root .accordion-content-expanded {\n  background-color: #fff;\n  border-left: 1px solid #b9bec2;\n  margin-left: 0.6rem;\n  padding-left: 0.7rem;\n  overflow: visible;\n  text-align: left;\n}");

var JsonNode = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    var accordionIcon = ((_a = props.accordionProps) === null || _a === void 0 ? void 0 : _a.icon) || fa.FaAngleRight;
    return (React__namespace.createElement("div", { style: (_b = props.styles) === null || _b === void 0 ? void 0 : _b.root, className: 'jsonnode-root' }, checkIfObjectOrArray(props.value) ?
        React__namespace.createElement(Accordion__default["default"], __assign({}, __assign(__assign({}, props.accordionProps), { title: props.title || "", styles: ((_c = props.accordionProps) === null || _c === void 0 ? void 0 : _c.styles) || ((_d = props.styles) === null || _d === void 0 ? void 0 : _d.accordion), icon: accordionIcon })),
            React__namespace.createElement(JsonViewer, { data: props.value || {}, jsonNodeProps: props, styles: props.jsonViewerStyles }))
        :
            React__namespace.createElement("div", { style: (_e = props.styles) === null || _e === void 0 ? void 0 : _e.content, className: 'jsonnode-content' },
                React__namespace.createElement("span", { style: (_f = props.styles) === null || _f === void 0 ? void 0 : _f.title, className: 'jsonnode-title' }, props.title),
                props.seperator && React__namespace.createElement("span", { style: (_g = props.styles) === null || _g === void 0 ? void 0 : _g.seperator, className: 'jsonnode-seperator' }, props.seperator),
                React__namespace.createElement("span", { style: (_h = props.styles) === null || _h === void 0 ? void 0 : _h.value, className: 'jsonnode-value' }, getObjectValueAsString(props.value)))));
};
var checkIfObjectOrArray = function (value) {
    var _a;
    return value && typeof value === 'object' && !(checkIfOtherObject(value)) && ((_a = Object.keys(value)) === null || _a === void 0 ? void 0 : _a.length);
};
var checkIfOtherObject = function (value) {
    return value && typeof value === 'object' && (value instanceof Date || value instanceof Boolean || value instanceof Number || value instanceof String);
};
var getObjectValueAsString = function (value) {
    var _a;
    if (typeof value === 'object' && value) {
        if (value instanceof Date || value instanceof Boolean || value instanceof Number || value instanceof String) {
            return value.toString();
        }
        else if ((value instanceof Object || value instanceof Array) && ((_a = Object.keys(value)) === null || _a === void 0 ? void 0 : _a.length) === 0) {
            return value instanceof Array ? "[]" : "{}";
        }
    }
    return value === undefined ? "undefined" : value ? value.toString() : "null";
};
JsonNode.defaultProps = {
    seperator: ':'
};

var JsonViewer = function (props) {
    var _a;
    return (React__namespace.createElement("div", { style: (_a = props.styles) === null || _a === void 0 ? void 0 : _a.root, className: "jsonviewer-root" }, Object.entries(props.data).map(function (node, idx) {
        var _a, _b, _c, _d;
        return React__namespace.createElement(JsonNode, { key: idx, title: node[0], value: node[1], seperator: (_a = props.jsonNodeProps) === null || _a === void 0 ? void 0 : _a.seperator, styles: ((_b = props.jsonNodeProps) === null || _b === void 0 ? void 0 : _b.styles) || ((_c = props.styles) === null || _c === void 0 ? void 0 : _c.jsonNode), accordionProps: (_d = props.jsonNodeProps) === null || _d === void 0 ? void 0 : _d.accordionProps, jsonViewerStyles: props.styles });
    })));
};

exports["default"] = JsonViewer;
//# sourceMappingURL=index.js.map
